import java.awt.*;
import java.lang.*;
import java.io.*;
import java.util.*;

public class ThreatDetection 
{

	// Maximum number of variables
	public static int	NUM_AC = 4;     	/* number of AC    */
	public static int	NUM_RADAR = 10;		/* number of Radar */
	public static int	NUM_AIRBASE = 2;	/* number of AIRBASE */
	public static int	NUM_LEG = 4;		/* number of legs */
	public static int SpeedTimer = 1000;

	public static PrintStream ff1 = null;

	public static String[] radar_name = { "MON", "NYC", "ALB", "ROM", "SYR" };
	public static double[][] radar_loc = new double[NUM_RADAR][3];

	public static double[][][] ac_loc = new double[NUM_AC][NUM_LEG+1][4];

	public static double[][] airbase_loc = new double[NUM_AIRBASE][3];

	public static int[] ac_leg = new int[NUM_AC];

	public static int[]  rflag = {1,1,1,1,1,1,1,1,1,1}; /* radar availibility    */
	public static int[]  airbaseflag = {0, 0};          /* airbase  availibility */
  
	public static int  History = 0;                   /* flag for whole track of AC     */
	public static int  Interceptorflag=0;             /* flag for interceptor           */
	public static int  InterceptorLaunchedflag=0;     /* flag for interceptor launching */
	public static int  KillTargetflag =0;             /* flag for destroying target     */

	public static double maxrange, minelevation;
	public static double[][] ac_cur_location = new double[NUM_AC][3]; 
	public static double[][][] ac_cur_rae = new double[NUM_RADAR][NUM_AC][3]; 
	RFrame   r[] = new RFrame[NUM_RADAR];

	ACFrame ac[] =  new ACFrame[NUM_AC];

	Simulation_TD simulation_TD;
	int count;
	ChangeSimTime  Time;

	// define variables for JavaDVM by I. Ra 05/02/98
	public static int   targc;      // no. of arguments for the task
	// argument list for the task
	public static String targs[] = new String[20];
	public static String mytaskname; // my task name

	public static int   mytaskid;   // my task id
	public static int   first_input_port; // 1st input port
	public static int   first_output_port; // 1st output port

	public	int	no_ac;
	public	int	no_radar;
	public	int	no_airbase;

	public ThreatDetection() {
	}

	public void set_ac_cur_rae(int radar, int ac) {

		ac_cur_rae[radar][ac][0] = r[radar].Range;
		ac_cur_rae[radar][ac][1] = r[radar].Azimuth;
		ac_cur_rae[radar][ac][2] = r[radar].Elevation;

	} /* end set_ac_cur_rae() */

	public void initialize() {
		int i;
   
		Time = new ChangeSimTime(); 

		for ( i = 0 ; i < no_ac ; i++ ) {
			ac[i] = new ACFrame(ac_leg[i],
				ac_loc[i][0][0], ac_loc[i][0][1], ac_loc[i][0][2], ac_loc[i][0][3],
				ac_loc[i][1][0], ac_loc[i][1][1], ac_loc[i][1][2], ac_loc[i][1][3],
				ac_loc[i][2][0], ac_loc[i][2][1], ac_loc[i][2][2], ac_loc[i][2][3],
				ac_loc[i][3][0], ac_loc[i][3][1], ac_loc[i][3][2], ac_loc[i][3][3],
				ac_loc[i][4][0], ac_loc[i][4][1], ac_loc[i][4][2], ac_loc[i][4][3]);
		}

		for ( i = 0 ; i < no_radar ; i++ ) {
			r[i] = new RFrame(4, radar_loc[i][0], radar_loc[i][1], radar_loc[i][2]);
		}
    
		Simulation_TD simulation_TD = new Simulation_TD(this);

	}/* end initialize() */

	public void file_read() {
		int	i, j, k;
		boolean loop = true;
		String	first_input_filename;
		String	str = null;
		StringTokenizer st = null;

		first_input_filename = JavaDVM.vdceinputname(mytaskid, first_input_port);
		ff1.println("external input file name : " + first_input_filename);

		try {
			BufferedReader reader = new BufferedReader(new FileReader(first_input_filename));

			loop = true;
			while( loop ) {
				str = reader.readLine();
				if ( str.startsWith("//") ) {
					ff1.println("Comment : " + str);
				}
				else {
					loop = false;
				}
			}
			st = new StringTokenizer(str);
			no_ac =	Integer.valueOf(st.nextToken()).intValue();

			loop = true;
			while( loop ) {
				str = reader.readLine();
				if ( str.startsWith("//") ) {
					ff1.println("Comment : " + str);
				}
				else {
					loop = false;
				}
			}
			st = new StringTokenizer(str);
			no_radar =	Integer.valueOf(st.nextToken()).intValue();

			loop = true;
			while( loop ) {
				str = reader.readLine();
				if ( str.startsWith("//") ) {
					ff1.println("Comment : " + str);
				}
				else {
					loop = false;
				}
			}
			st = new StringTokenizer(str);
			no_airbase =	Integer.valueOf(st.nextToken()).intValue();

			ff1.println("ac : " + no_ac + " radar : " + no_radar + " airbase : " + no_airbase);

			// ac_loc
			for ( i = 0 ; i < no_ac ; i++ ) {
				loop = true;
				while( loop ) {
					str = reader.readLine();
					if ( str.startsWith("//") ) {
						ff1.println("Comment : " + str);
					}
					else {
						loop = false;
					}
				}
				st = new StringTokenizer(str);
				ac_leg[i] =	Integer.valueOf(st.nextToken()).intValue();

				for ( j = 0 ; j < 5 ; j++ ) {
					loop = true;
					while( loop ) {
						str = reader.readLine();
						if ( str.startsWith("//") ) {
							ff1.println("Comment : " + str);
						}
						else {
							loop = false;
						}
					}
					st = new StringTokenizer(str);
					for ( k = 0 ; k < 4 ; k++ ) {
						ac_loc[i][j][k] =  Double.valueOf(st.nextToken()).doubleValue();
					}
				}
			}

			for ( i = 0 ; i < no_ac ; i++ ) {
				ff1.println("ac " + i);
				ff1.println("	leg = " + ac_leg[i]);
				for ( j = 0 ; j < 5 ; j++ ) {
					ff1.print("		");
					for ( k = 0 ; k < 4 ; k++ ) {
						ff1.print(ac_loc[i][j][k] + "   ");
					}
					ff1.println("");
				}
			}

			// radar_loc
			for ( i = 0 ; i < no_radar ; i++ ) {
				loop = true;
				while( loop ) {
					str = reader.readLine();
					if ( str.startsWith("//") ) {
						ff1.println("Comment : " + str);
					}
					else {
						loop = false;
					}
				}
				st = new StringTokenizer(str);
				for ( j = 0 ; j < 3 ; j++ ) {
					radar_loc[i][j] =  Double.valueOf(st.nextToken()).doubleValue();
				}
			}

			for ( i = 0 ; i < no_radar ; i++ ) {
				ff1.println("radar " + i);
				ff1.print("		");
				for ( j = 0 ; j < 3 ; j++ ) {
					ff1.print(radar_loc[i][j] + "   ");
				}
				ff1.println("");
			}

			// airbase_loc
			for ( i = 0 ; i < no_airbase ; i++ ) {
				loop = true;
				while( loop ) {
					str = reader.readLine();
					if ( str.startsWith("//") ) {
						ff1.println("Comment : " + str);
					}
					else {
						loop = false;
					}
				}
				st = new StringTokenizer(str);
				for ( j = 0 ; j < 3 ; j++ ) {
					airbase_loc[i][j] =  Double.valueOf(st.nextToken()).doubleValue();
				}
			}

			for ( i = 0 ; i < no_airbase ; i++ ) {
				ff1.println("airbase " + i);
				ff1.print("		");
				for ( j = 0 ; j < 3 ; j++ ) {
					ff1.print(airbase_loc[i][j] + "   ");
				}
				ff1.println("");
			}

		}
		catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static void main(String[] args) {

		// define for JavaDVM
		int result;
		Integer inport,outport;
		String  out_file;

		out_file = "/tmp/Threat";

		try {
			FileOutputStream f_out = new FileOutputStream(out_file);
			ff1 = new PrintStream(f_out);
			ff1.println("Threat start!");
		}
		catch(IOException e) {
			System.exit(1);
		}

		// starts DVM initilization
		ff1.println("JavaDVM.vacdmain is called"+args[0]+" "+args[1]+" "+
			args[2]+" "+args[3]+" "+args[4]+" "+args[5]+" "+args[6]+" "+
			args[7]+ " "+args[8]+" "+args[9]);

		result = JavaDVM.vdcemain(args,targs);

		try {
			ff1.println("After vdcemain");
		}
		catch(Exception e) {
			System.exit(1);
		}

		if (result != 0) {
			ff1.println("Java DVM init has been done.");
			//inport = Integer.valueOf(targs[1]);
			//first_input_port = inport.intValue();
			first_input_port = 1;
			//outport = Integer.valueOf(targs[2]);
			//first_output_port = outport.intValue();
			first_output_port = 1;
			ff1.println("inport= "+first_input_port+" outport= "+first_output_port);

			mytaskname = JavaDVM.vdcegetmyname();   // get task name
			ff1.println("done get mytaskname");

			mytaskid = JavaDVM.vdcegetmyid();       // get task id
			ff1.println("done get mytaskid");
			ff1.println("Threat Detection is started"+" "+mytaskname);

			ThreatDetection f = new ThreatDetection();
			ff1.println("Done Threat Detection");

			f.file_read();

			f.initialize();

		}
		else {
			ff1.println("Java DVM init has not been done due to errors!.");
		}
	}
}/* end class TRACK */